(function() {
  //!/usr/bin/env coffee
  var args, colors, file, fs, noon, noonFile, oldversion, pack, path, ref, ref1, semver;

  fs = require('fs');

  path = require('path');

  colors = require('colors');

  noon = require('noon');

  semver = require('semver');

  args = require('karg')("\nbump\n    semver     . ? semver or increment type . *\n    increment  . ? increment type: major, minor or . = patch");

  if ((args.semver != null) && !semver.valid(args.semver)) {
    if ((ref = args.semver) === 'major' || ref === 'minor' || ref === 'patch') {
      args.increment = args.semver;
      delete args.semver;
    } else {
      console.log(`not a semver version: ${args.semver.yellow}`.red);
      process.exit(1);
    }
  }

  file = path.join(process.cwd(), 'package.json');

  pack = require(file);

  oldversion = pack.version;

  if (!semver.valid(oldversion)) {
    oldversion = "0.0.0";
  }

  pack.version = (ref1 = args.semver) != null ? ref1 : semver.inc(oldversion, args.increment);

  console.log(path.basename(path.dirname(file)).green, oldversion.gray, '►'.gray.dim, pack.version.bold.red);

  // write package.json
  fs.writeFileSync(file, JSON.stringify(pack, null, '  '), {
    encoding: 'utf8'
  });

  // write package.noon if it exists
  noonFile = path.join(process.cwd(), 'package.noon');

  if (fs.existsSync(noonFile)) {
    noon.save(noonFile, pack, {
      indent: '  ',
      maxalign: 16
    });
  }

}).call(this);
